
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>解密随机数生成器（二）——从java源码看线性同余算法 / iVAN</title>

    <meta name="description" content="解密随机数生成器（二）——从java源码看线性同余算法 Random Java中的Random类生成的是伪随机数,使用的是48-bit的种子,然后调用一个linear congruential formula线性同余方程(Donald Knuth的编程艺术的3.2.1节) 如果两个Random实例使用相同的种子,并且调用同样的函数,那么生成的sequence是相同的 也可以调用Math.random()生成随机数 Random实例是线程安全的,但是并发使用Random实例会影响效率,可以考虑使用java.util.concurrent.ThreadL">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">解密随机数生成器（二）——从java源码看线性同余算法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Random</p>
<p>Java中的Random类生成的是伪随机数，使用的是48-bit的种子，然后调用一个linear congruential formula<strong>线性同余</strong>方程（Donald Knuth的编程艺术的3.2.1节）</p>
<p>如果两个Random实例使用相同的种子，并且调用同样的函数，那么生成的sequence是相同的</p>
<p>也可以调用Math.random()生成随机数</p>
<p>Random实例是<strong>线程安全</strong>的，但是并发使用Random实例会影响效率，可以考虑使用java.util.concurrent.ThreadLocalRandom(jdk1.7)。</p>
<pre>/**
 * A random number generator isolated to the current thread.  Like the
 * global {@link java.util.Random} generator used by the {@link
 * java.lang.Math} class, a {@code ThreadLocalRandom} is initialized
 * with an internally generated seed that may not otherwise be
 * modified. When applicable, use of {@code ThreadLocalRandom} rather
 * than shared {@code Random} objects in concurrent programs will
 * typically encounter much less overhead and contention.  Use of
 * {@code ThreadLocalRandom} is particularly appropriate when multiple
 * tasks (for example, each a {@link ForkJoinTask}) use random numbers
 * in parallel in thread pools.
 *
 * &lt;p&gt;Usages of this class should typically be of the form:
 * {@code ThreadLocalRandom.current().nextX(...)} (where
 * {@code X} is {@code Int}, {@code Long}, etc).
 * When all usages are of this form, it is never possible to
 * accidently share a {@code ThreadLocalRandom} across multiple threads.
 *
 * &lt;p&gt;This class also provides additional commonly used bounded random
 * generation methods.
 *
 * &lt;p&gt;Instances of {@code ThreadLocalRandom} are not cryptographically
 * secure.  Consider instead using {@link java.security.SecureRandom}
 * in security-sensitive applications. Additionally,
 * default-constructed instances do not use a cryptographically random
 * seed unless the {@linkplain System#getProperty system property}
 * {@code java.util.secureRandomSeed} is set to {@code true}.
 *
 * @since 1.7
 * @author Doug Lea
 */
public class ThreadLocalRandom extends Random {</pre>
<p> </p>
<pre> int nextInt = ThreadLocalRandom.current().nextInt(10);</pre>
<p> </p>
<p>Random实例不是安全可靠的加密，可以使用java.security.SecureRandom来提供一个可靠的加密。</p>
<p>Random implements Serializable <strong>可序列化</strong>的</p>
<p>AtomicLong seed 原子变量</p>
<p>解密随机数生成器（2）——从java源码看线性同余算法</p>
<p>上篇博客中，我们了解了基于物理现象的真随机数生成器，然而，真随机数产生速度较慢，为了实际计算需要，计算机中的随机数都是由程序算法，也就是某些公式函数生成的，只不过对于同一随机种子与函数，得到的随机数列是一定的，因此得到的随机数可预测且有周期，不能算是真正的随机数，因此称为伪随机数（Pseudo Random Number）。</p>
<p> </p>
<p>不过，别看到伪字就瞧不起，这里面也是有学问的，看似几个简简单单的公式可能是前辈们努力了几代的成果，相关的研究可以写好几本书了！<br />顺便提一下，亚裔唯一图灵奖得主姚期智，研究的就是伪随机数生成论（The pseudo random number generating theory）。<br />在这里，我重点介绍两个常用的算法：<strong>同余法</strong>（Congruential method）和梅森旋转算法（Mersenne twister）</p>
<p> </p>
<p>1、同余法</p>
<p>同余法（Congruential method）是很常用的一种随机数生成方法，在很多编程语言中有应用，最明显的就是java了，java.util.Random类中用的就是同余法中的一种——线性同余法（Linear congruential method），除此之外还有乘同余法（Multiplicative congruential method）和混合同余法（Mixed congruential method）。好了，现在我们就打开java的源代码，看一看线性同余法的真面目！</p>
<p> </p>
<p>在Eclipse中输入java.util.Random，按F3转到Random类的源代码：</p>
<p>首先，我们看到这样一段说明：</p>
<p>翻译过来是：</p>
<p>这个类的一个实现是用来生成一串伪随机数。这个类用了一个48位的种子，被线性同余公式修改用来生成随机数。（见Donald Kunth《计算机编程的艺术》第二卷，章节3.2.1）</p>
<p>显然，java的Random类使用的是线性同余法来得到随机数的。</p>
<p>接着往下看，我们找到了它的构造函数与几个方法，里面包含了获得48位种子的过程：</p>
<pre>private static final AtomicLong seedUniquifier = new AtomicLong(8682522807148012L);
/**
 * Creates a new random number generator. This constructor sets
 * the seed of the random number generator to a value very likely
 * to be distinct from any other invocation of this constructor.
 */
public Random() {
    this(seedUniquifier() ^ System.nanoTime());
}

private static long seedUniquifier() {
    // L'Ecuyer, "Tables of Linear Congruential Generators of
    // Different Sizes and Good Lattice Structure", 1999
    for (;;) {
        long current = seedUniquifier.get();
        long next = current * 181783497276652981L;
        if (seedUniquifier.compareAndSet(current, next))
            return next;
    }
}

private static final AtomicLong seedUniquifier
    = new AtomicLong(8682522807148012L);
public Random(long seed) {
    if (getClass() == Random.class)
        this.seed = new AtomicLong(initialScramble(seed));
    else {
        // subclass might have overriden setSeed
        this.seed = new AtomicLong();
        setSeed(seed);
    }
}
private static long initialScramble(long seed) {
    return (seed ^ multiplier) &amp; mask;
}
   </pre>
<p> </p>
<pre>java.util.concurrent.atomic.AtomicLong
public final boolean compareAndSet(long expect,
                                   long update)
Atomically sets the value to the given updated value if the <strong>current</strong> value <strong>==</strong> the <strong>expected</strong> value.
Parameters:
expect - the expected value
update - the new value
Returns:
true if successful. False return indicates that the actual value was not equal to the expected value.</pre>
<p> </p>
<p>这里使用了System.nanoTime()方法来得到一个纳秒级的时间量，参与48位种子的构成，然后还进行了一个很变态的运算——不断乘以181783497276652981L，直到某一次相乘前后结果相同——来进一步增大随机性，这里的nanotime可以算是一个真随机数，不过有必要提的是，nanoTime和我们常用的currenttime方法不同，返回的不是从1970年1月1日到现在的时间，而是一个随机的数——只用来前后比较计算一个时间段，比如一行代码的运行时间，数据库导入的时间等，而不能用来计算今天是哪一天。</p>
<pre>    /**
     * Returns the current value of the running Java Virtual Machine's
     * high-resolution time source, in nanoseconds.
     *
     * &lt;p&gt;This method can <strong>only</strong> be used to measure elapsed time and is
     * not related to any other notion of system or wall-clock time.
     * The value returned represents nanoseconds since some fixed but
     * arbitrary &lt;i&gt;origin&lt;/i&gt; time (perhaps in the future, so values
     * may be negative).  The same origin is used by all invocations of
     * this method in an instance of a Java virtual machine; other
     * virtual machine instances are likely to use a different origin.
     *
     * &lt;p&gt;This method provides nanosecond precision, but not necessarily
     * nanosecond resolution (that is, how frequently the value changes)
     * - no guarantees are made except that the resolution is at least as
     * good as that of {@link #currentTimeMillis()}.
     *
     * &lt;p&gt;Differences in successive calls that span greater than
     * approximately 292 years (2&lt;sup&gt;63&lt;/sup&gt; nanoseconds) will not
     * correctly compute elapsed time due to numerical overflow.
     *
     * &lt;p&gt;The values returned by this method become meaningful only when
     * the difference between two such values, obtained within the same
     * instance of a Java virtual machine, is computed.
     *
     * &lt;p&gt; For example, <strong>to measure how long</strong> some code takes to execute:
     *  &lt;pre&gt; {@code
     * long startTime = System.nanoTime();
     * // ... the code being measured ...
     * long <strong>estimatedTime</strong> = System.nanoTime() - startTime;}&lt;/pre&gt;
     *
     * &lt;p&gt;To compare two nanoTime values
     *  &lt;pre&gt; {@code
     * long t0 = System.nanoTime();
     * ...
     * long t1 = System.nanoTime();}&lt;/pre&gt;
     *
     * one should use {@code t1 - t0 &lt; 0}, not {@code t1 &lt; t0},
     * because of the possibility of numerical overflow.
     *
     * @return the current value of the running Java Virtual Machine's
     *         high-resolution time source, in nanoseconds
     * @since 1.5
     */
    public static native long nanoTime();</pre>
<p> </p>
<p>好了，现在我不得不佩服这位工程师的变态了：到目前为止，这个程序已经至少进行了三次随机：</p>
<p> </p>
<p>1、获得一个长整形数作为“初始种子”（系统默认的是8682522807148012L）</p>
<p>2、不断与一个变态的数——181783497276652981L相乘（天知道这些数是不是工程师随便滚键盘滚出来的-.-）得到一个不能预测的值，直到 能把这个不能事先预期的值 赋给Random对象的静态常量seedUniquifier 。因为多线程环境下赋值操作可能失败，就for(;;)来保证一定要赋值成功</p>
<p>3、与系统随机出来的nanotime值作异或运算，得到最终的种子</p>
<p>再往下看，就是我们常用的得到随机数的方法了，我首先找到了最常用的nextInt（）函数，代码如下：</p>
<pre>public int nextInt() {
    return next(32);
}</pre>
<p>代码很简洁，直接跳到了next函数：</p>
<pre>protected int next(int bits) {
    long oldseed, nextseed;
    AtomicLong seed = this.seed;
    do {
        oldseed = seed.get();
        nextseed = (oldseed * multiplier + addend) &amp; mask;
    } while (!seed.compareAndSet(oldseed, nextseed));
    return (int)(nextseed &gt;&gt;&gt; (48 - bits));
}</pre>

<pre></pre>
<p>OK,祝贺一下怎么样，因为我们已经深入到的线性同余法的核心了——没错，就是这几行代码！</p>
<p>在分析这段代码前，先来简要介绍一下线性同余法。</p>
<p> </p>
<p>在程序中为了使表达式的结果<strong>小于某个值</strong>，我们常常采用<strong>取余</strong>的操作，结果是同一个<strong>除数的余数</strong>，这种方法叫同余法（Congruential method）。</p>
<p>线性同余法是一个很古老的随机数生成算法，它的数学形式如下：</p>
<p>Xn+1 = (a*Xn+c)(mod m) </p>
<p>其中，</p>
<p>m&gt;0,0&lt;a&lt;m,0&lt;c&lt;m</p>
<p> </p>
<p>这里Xn这个序列生成一系列的随机数，X0是种子。随机数产生的质量与m，a，c三个参数的选取有很大关系。这些随机数并不是真正的随机，而是满足在某一周期内随机分布，这个周期的最长为m。根据Hull-Dobell Theorem，当且仅当：</p>
<p>1. c和m互素;</p>
<p>2. a-1可被所有m的质因数整除;</p>
<p>3. 当m是4的整数倍，a-1也是4的整数倍时，周期为m。所以m一般都设置的很大，以延长周期。</p>
<p>现在我们回过头来看刚才的程序，注意这行代码：</p>
<pre>nextseed = (oldseed * multiplier + addend) &amp; mask;</pre>
<p>和Xn+1=(a*Xn+c)(mod m)的形式很像有木有！</p>
<p>没错，就是这一行代码应用到了线性同余法公式！不过还有一个问题：怎么没见取余符号？嘿嘿，先让我们看看三个变量的数值声明：</p>
<p> </p>
<pre>    private static final long multiplier = 0x5DEECE66DL;
    private static final long addend = 0xBL;
    private static final long mask = (1L &lt;&lt; 48) - 1;</pre>
<p> </p>
<p>其中<em>multiplier</em>和<em>addend</em>分别代表公式中的a和c，很好理解，但mask代表什么呢？其实，x &amp; [(1L &lt;&lt; 48)–1]与 x（mod 2^48）等价。解释如下：</p>
<p> </p>
<p>x对于2的N次幂取余，由于除数是2的N次幂，如：</p>
<p>0001，0010，0100，1000。。。。</p>
<p>相当于把x的二进制形式向右移N位，此时移到小数点右侧的就是余数，如：</p>
<p>13 = 1101    8 = 1000</p>
<p>13 / 8 = 1.101，所以小数点右侧的101就是余数，化成十进制就是5</p>
<p>然而，无论是C语言还是java,位运算移走的数显然都一去不复返了。（什么，你说在CF寄存器中？好吧，太高端了点，其实还有更给力的方法）有什么好办法保护这些即将逝去的数据呢？</p>
<p>学着上面的mask，我们不妨试着把2的N次幂减一：</p>
<p>0000，0001，0011，0111，01111，011111。。。</p>
<p>怎么样，有启发了吗？</p>
<p>我们知道，某个数（限0和1）与1作与（&amp;）操作，结果还是它本身；而与0作与操作结果总是0，即：</p>
<p>a &amp; 1 = a,  a &amp; 0 = 0</p>
<p>而我们将x对2^N取余操作希望达到的目的可以理解为：</p>
<p>1、所有比2^N位（包括2^N那一位）全都为0</p>
<p>2、所有比2^N低的位保持原样</p>
<p>因此， x &amp; （2^N-1）与x（mod 2^N）运算等价，还是13与8的例子：</p>
<p>1101 % 1000 = 0101    1101 &amp; 0111 = 0101</p>
<p>二者结果一致。</p>
<p>嘿嘿，讲明白了这个与运算的含义，我想上面那行代码的含义应该很明了了，就是线性同余公式的直接套用，其中a = 0x5DEECE66DL, c = 0xBL, m = 2^48，就可以得到一个48位的随机数，而且这个谨慎的工程师进行了迭代，增加结果的随机性。再把结果移位，就可以得到指定位数的随机数。</p>
<p>接下来我们研究一下更常用的一个函数——带参数n的nextInt：</p>
<p> </p>
<pre>    public int nextInt(int n) {
        if (n <strong>&lt;= 0</strong>)
            throw new IllegalArgumentException("n must be positive");

        if ((n &amp; -n) == n)  // i.e., n is a power of 2
            return (int)((n * (long)next(31)) &gt;&gt; 31);

        int bits, val;
        do {
            bits = next(31);
            val = bits % n;
        } while (bits - val + (n-1) &lt; 0);
        return val;
    }</pre>
<p> </p>
<p>显然，这里基本的思路还是一样的，先调用next函数生成一个31位的随机数（int类型的范围），再对参数n进行判断，如果n恰好为2的方幂，那么直接移位就可以得到想要的结果；如果不是2的方幂，那么就关于n取余，最终使结果在[0,n)范围内。另外，do-while语句的目的应该是防止结果为负数。</p>
<p>你也许会好奇为什么(n &amp; -n) == n可以判断一个数是不是2的次方幂，其实我也是研究了一番才弄明白的，其实，这主要与补码的特性有关：</p>
<p>众所周知，计算机中负数使用补码储存的（不懂什么是补码的自己百度恶补），举几组例子：</p>
<p>2 ：0000 0010      -2 ：1111 1110</p>
<p>8 ：0000 1000      -8 ：1111 1000</p>
<p>18 ：0001 0010     -18 ：1110 1110</p>
<p>20 ：0001 0100     -20 ：1110 1100</p>
<p>不知道大家有没有注意到，补码有一个特性，就是可以对于两个相反数n与-n，有且只有最低一个为1的位数字相同且都为1，而更低的位全为0，更高的位各不相同。因此两数作按位与操作后只有一位为1，而能满足这个结果仍为n的只能是原本就只有一位是1的数，也就是恰好是2的次方幂的数了。</p>
<p>不过个人觉得还有一种更好的判断2的次方幂的方法：</p>
<p>n &amp; (n-1) == 0</p>
<p>感兴趣的也可以自己研究一下^o^。</p>
<p>好了，线性同余法就介绍到这了，下面简要介绍一下另一种同余法——乘同余法（Multiplicative congruential method）。</p>
<p>上文中的线性同余法，主要用来生成整数，而某些情景下，比如科研中，常常只需要（0，1）之间的小数，这时，乘同余法是更好的选择，它的基本公式和线性同余法很像：</p>
<p>Xn+1=（a*Xn ）(mod m ）</p>
<p>其实只是令线性公式中的c=0而已。只不过，为了得到小数，我们多做一步：</p>
<p>Yn = Xn/m  </p>
<p>由于Xn是m的余数，所以Yn的值介于0与1之间，由此到（0，1）区间上的随机数列。</p>
<p>除此之外，还有混合同余法，二次同余法，三次同余法等类似的方法，公式类似，也各有优劣，在此不详细介绍了。</p>
<p>同余法优势在计算速度快，内存消耗少。但是，因为相邻的随机数并不独立，序列关联性较大。所以，对于随机数质量要求高的应用，特别是很多科研领域，并不适合用这种方法。</p>
<p>不要走开，下篇博客介绍一个更给力的算法——梅森旋转算法（Mersenne Twister），持续关注啊！</p>
<p>http://www.myexception.cn/program/1609435.html</p>
<p> </p>
<p>Atomic 从JDK5开始, java.util.concurrent包里提供了很多面向并发编程的类. 使用这些类在多核CPU的机器上会有比较好的性能.<br />主要原因是这些类里面大多使用(失败-重试方式的)乐观锁而不是synchronized方式的悲观锁.</p>
<p>今天有时间跟踪了一下AtomicInteger的incrementAndGet的实现.<br />本人对并发编程也不是特别了解, 在这里就是做个笔记, 方便以后再深入研究.</p>
<p>1. incrementAndGet的实现</p>
<p>    public final int incrementAndGet() {<br />        for (;;) {<br />            int current = get();<br />            int next = current + 1;<br />            if (<strong>compareAndSet</strong>(current, next))<br />                return next;<br />        }<br />    }</p>
<p>首先可以看到他是通过一个无限循环(spin)直到increment成功为止.  <br />循环的内容是<br />1.取得当前值<br />2.计算+1后的值<br />3.如果当前值还有效(没有被)的话设置那个+1后的值<br />4.如果赋值<strong>没成功(<br />当前值已经无效了即被别的线程改过了.<br />expect这个参数就是用来校验当前值是否被别的参数更改了<br />)</strong>, 再从1开始.</p>
<p>2. compareAndSet的实现</p>
<p>    public final boolean compareAndSet(int expect, int update) {<br />        return unsafe.compareAndSwapInt(this, valueOffset, expect, update);<br />    }</p>
<p>直接调用的是UnSafe这个类的compareAndSwapInt方法<br />全称是sun.misc.Unsafe. 这个类是Oracle(Sun)提供的实现. 可以在别的公司的JDK里就不是这个类了</p>
<p>3. compareAndSwapInt的实现</p>
<p>    /**<br />     * Atomically update Java variable to &lt;tt&gt;x&lt;/tt&gt; if it is currently<br />     * holding &lt;tt&gt;expected&lt;/tt&gt;.<br />     * @return &lt;tt&gt;true&lt;/tt&gt; if successful<br />     */<br />    public final native boolean compareAndSwapInt(Object o, long offset,<br />                                                  int expected,<br />                                                  int x);</p>
<p>可以看到, 不是用Java实现的, 而是通过JNI调用操作系统的原生程序.</p>
<p>4. compareAndSwapInt的native实现<br />如果你下载了OpenJDK的源代码的话在hotspot\src\share\vm\prims\目录下可以找到unsafe.cpp</p>
<p>UNSAFE_ENTRY(jboolean, Unsafe_CompareAndSwapInt(JNIEnv *env, jobject unsafe, jobject obj, jlong offset, jint e, jint x))<br />  UnsafeWrapper("Unsafe_CompareAndSwapInt");<br />  oop p = JNIHandles::resolve(obj);<br />  jint* addr = (jint *) index_oop_from_field_offset_long(p, offset);<br />  return (jint)(Atomic::cmpxchg(x, addr, e)) == e;<br />UNSAFE_END</p>
<p>可以看到实际上调用Atomic类的cmpxchg方法.</p>
<p>5. Atomic的cmpxchg<br />这个类的实现是跟操作系统有关, 跟CPU架构也有关, 如果是windows下x86的架构<br />实现在hotspot\src\os_cpu\windows_x86\vm\目录的atomic_windows_x86.inline.hpp文件里</p>
<p>inline jint     Atomic::cmpxchg    (jint     exchange_value, volatile jint*     dest, jint     compare_value) {<br />  // alternative for InterlockedCompareExchange<br />  int mp = os::is_MP();<br />  __asm {<br />    mov edx, dest<br />    mov ecx, exchange_value<br />    mov eax, compare_value<br />    LOCK_IF_MP(mp)<br />    cmpxchg dword ptr [edx], ecx<br />  }<br />}</p>
<p>在这里可以看到是用嵌入的汇编实现的, 关键CPU指令是 cmpxchg<br />到这里没法再往下找代码了. 也就是说CAS的原子性实际上是CPU实现的. 其实在这一点上还是有排他锁的. 只是比起用synchronized, 这里的排他时间要短的多. 所以在多线程情况下性能会比较好.</p>
<p>代码里有个alternative for InterlockedCompareExchange<br />这个InterlockedCompareExchange是WINAPI里的一个函数, 做的事情和上面这段汇编是一样的<br />http://msdn.microsoft.com/en-us/library/windows/desktop/ms683560%28v=vs.85%29.aspx</p>
<p>6. 最后再贴一下x86的cmpxchg指定</p>
<h3>Opcode CMPXCHG</h3>
<p>CPU: I486+ <br />Type of Instruction: User </p>
<p>Instruction: CMPXCHG dest, src </p>
<p>Description: Compares the accumulator with dest. If equal the "dest" <br />is loaded with "src", otherwise the accumulator is loaded <br />with "dest". </p>
<p>Flags Affected:	AF, CF, OF, PF, SF, ZF </p>
<p>CPU mode: RM,PM,VM,SMM <br />+++++++++++++++++++++++ <br />Clocks: <br />CMPXCHG reg, reg	6 <br />CMPXCHG mem, reg	7 (10 if compartion fails) </p>
<p>http://www.blogjava.net/mstar/archive/2013/04/24/398351.html</p>
<p>姚期智：<br />他先是进入清华大学高等研究中心任全职教授。之后主导成立了一个“姚班”！<br />之所以发起成立这个实验班，是因为他感觉当前，中国的计算机科学本科教育水平，与麻省理工、斯坦福等，国外一流大学的教学水平，仍有一定的差距，因此，他希望能以他在国外，多年的理论研究与教学经验，把这个班的学生培养成为具有麻省理工、斯坦福同等水平的世界顶尖计算机科学人才。<br />他曾在致清华全校同学的信中写道：<br />“我们的目标并不是培养优秀的计算机软件程序员，我们要培养的是具有国际水平的一流计算机人才。”</p>
<p>他说：“我感觉物理学研究，与我原来想象的有些不同。恰在这个时期计算机刚刚兴起，有很多有意思的问题等着解决。我恰巧遇上这一学科，我认为这个选择是对的。”<br />“人生就像鸡蛋，从外打破是压力，从内打破是成长。只有不断自我修正，才会拥有向上爬的力量！”</p>
<p> </p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-14 02:06:27</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/random/" title="random">random</a>, <a href="https://www.iamivan.net/tag/%e7%ae%97%e6%b3%95/" title="算法">算法</a>, <a href="https://www.iamivan.net/tag/java/" title="java">java</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/%e6%ba%90%e7%a0%81/" title="源码">源码</a>, <a href="https://www.iamivan.net/tag/code/" title="code">code</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>解密随机数生成器（二）——从java源码看线性同余算法的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2PoYZp.html" rel="bookmark">关于查看Java源码问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于查看Java源码问题 为什么在Java源码中看不到迭代器Iterator里相关方法是怎么实现的,比如next(),hasnext()等 解决方案 迭代器是接口,方法是由它的子类实现的.可以使用快捷键,双击选中方法名,然后按下Ctrl加T就能看到实现类了. 解决方案二: Java源码问题查看java源码 Java source code怎么查看java api的源码? 解决方案三: 这个你可以在网上直接百度,参考源码啊			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrWW9xp.html" rel="bookmark">java源码阅读方法以及经验</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java源码阅读方法以及经验 如何更好的阅读java源码,更注重阅读哪些包里面的源码,当然连好的阅读源码的工具也说明一下更好了 解决方案 我在这里假设你在问怎么阅读jdk的源码,java源码这个名字有点奇怪. 你可以build 一个fast debug版本,然后使用debugger去调试你的程序,这样对程序是怎么调用的有很直观的视图. 其次,可以看看jdk里面的regression tests,里面有很多例子. 其次,openjdk提供了netbean的jdk project,你可以很			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze63Ajb.html" rel="bookmark">关于生成java源码的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 最近要做一个通过java源码生成另一套java源码,如根据以下代码:publicclasshelloword{publicStringtest=&quot;&quot;;publicvoidtest(){/*语句...*/}publicStringtest(){/*语句...*/returnresult;}} 生成如下代码:publicclasshelloword{publicStringtest=&quot;&quot;;publicvoidtest(){}publicStringtest()			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze63vxb.html" rel="bookmark">对象-java源码中一个抽象类初始化方法中包含一个super&lpar;&rpar;&comma;该怎么理解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java源码中一个抽象类初始化方法中包含一个super(),该怎么理解 package org.apache.http.params; import java.util.Set; /** * Abstract base class for parameter collections. * Type specific setters and getters are mapped to the abstract, * generic getters and setters. * * @si			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE6XRqM.html" rel="bookmark">java源码-输入年月日信息问题？完全不知道啊</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 输入年月日信息问题?完全不知道啊 这个题目怎么实现啊,一点点的思路都没有,不知道如何去计算,谁能给我个java源码啊???????????????????????? 解决方案 Calendar a = Calendar.getInstance(); a.set(2016, 0, 1); System.out.println(a.get(a.DAY_OF_YEAR)); //当前年月日在当前年的第几天 a.set(年,月-1,日). 解决方案二: #include &lt;stdio.h&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvmO7Ab.html" rel="bookmark">代码-JAVA源码应该怎么分模块进行解析与学习？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 JAVA源码应该怎么分模块进行解析与学习? 最近看过了JAVA虚拟机这本书,对JAVA源码也产生了兴趣,可是面对这么多的代码,无从下手,所以请大家给一下比较好的建议 解决方案 先找个工作,慢慢学习,在工作中遇到问题的时候,或者有空闲的时候,就开始看源码.可以从一个包一个包开始看.推荐从java.util包开始. 解决方案二: 可以先找几个常用的包看看,比如math,util什么的. 解决方案三: 一般来说,你应该知道源码的功能,按功能来划分模块. 解决方案四: 建议楼主不要单纯的为了看			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE4Vg9z.html" rel="bookmark">java源码-控制输出精确小数点的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 控制输出精确小数点的问题 这个题目怎么实现啊,一点点的思路都没有,不知道如何去计算,谁能给我个java源码啊???????????????????????? 解决方案 DecimalFormat d = new DecimalFormat(&quot;#.00&quot;); d.format(&quot;你的数字&quot;): 解决方案二: 你是想得到输出的值精确到小数点后几位吗? 如精确到小数点后7位: 0.1234567 解决方案三: Java提供了BigDecimal类可以精确设置保留			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmBQxwz.html" rel="bookmark">为什么在csdn中下载的java源码导入后有问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 为什么在csdn中下载的java源码不是不能导入,就是导入后有问题又找不到作者帮忙,谁能帮我远程看看呢?也希望上传者能有点说明性文档,一般下载者都是初学者,下载了各种问题你说怎么办? 解决方案 解决方案二:具体什么问题呢.是什么错误,是少jar吗?解决方案三:有一个是源代码有点乱,我新建一个项目然后把它复制进去的,也不知道是哪错了,还有一个是没有数据库的自己新建的数据库,然后运行,就出错了,你能否远程呢解决方案四: 解决方案五:引用3楼qq_14942305的回复:缺少spring的j			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJrx57z.html" rel="bookmark">Java源码解析Integer方法解读&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				toUnsignedString方法解读 看到Integer中有这样的一个方法把int转为Unsigned类型的字符串,但是有几个点不是很清楚,经过查询资料弄懂了,解读如下: /** * Convert the integer to an unsigned number. */ private static String toUnsignedString(int i, int shift) { char[] buf = new char[32]; int charPos = 32; int ra			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6kJgp.html" rel="bookmark" class="title">Photoshop打造艳丽的秋季暖色水景人物图片</a>
					<div>
						素材图片以绿色为主,调色的时候直接把主色转为秋季的橙黄色:然后把暗部调暗,并增加蓝色:再给图片局部渲染一些高光,增加层次感即可. 原图 最终效果 [1] [2] [3] [4] [5] [6] [7] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRydwdb.html" rel="bookmark" class="title">Word 2013中&OpenCurlyDoubleQuote;文件&rdquo;按钮的作用</a>
					<div>
						在Word2013文档中,&quot;文件&quot;按钮是一个类似于菜单的按钮,位于Word2013文档窗口的左上角.单击&quot;文件&quot;按钮可以打开&quot;文件&quot;窗口,其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jRANb.html" rel="bookmark" class="title">Word 2007使用&OpenCurlyDoubleQuote;仅保留文本&rdquo;选项粘贴文本时保留项目符号和编号</a>
					<div>
						在Word2007文档中,用户可以通过设置粘贴选项以确定使用&quot;仅保留文本&quot;选项粘贴文本时是否保留项目符号和编号,设置方法如下所述: 第1步,打开Word2007文档窗口,依次单击& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLVy2b.html" rel="bookmark" class="title">TCSH shell变量和特征配置</a>
					<div>
						TCSHshell可以使用户使用shell配置变量和特征配置自己的shell.也可以使用set命令设置特征.TCSH也有注册,注消以及何时进入TCSHshell的配置文件. 一.TCSH shell  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7PmxM.html" rel="bookmark" class="title">冒号和他的学生们（连载25）&mdash;&mdash;软件应变</a>
					<div>
						25．软件应变 潜其心能观天下之理,定其心能应天下之变 --&lt;吕坤·呻吟语&gt; 第七课刚一开堂,冒号就提了一个问题:&quot;如果把一个Java程序中所有的private关键字换成publ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZOY9ab.html" rel="bookmark" class="title">i See怎么批量给宝贝图片加相框</a>
					<div>
						  i See怎么批量给宝贝图片加相框?宝贝图片经相机拍下来后,需要用软件做一系列的处理,然后上传到相册.宝贝的种类多,每款宝贝的详图也多,为了方便在相册管理这些宝贝图片,需要系统地给宝贝图片更换一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2WAab.html" rel="bookmark" class="title">zbrush头部雕刻教程之五官的雕刻技巧</a>
					<div>
						  01 单击Tool&gt;Geometry&gt;Divide[工具&gt;几何体细分&gt;细分]按钮,提高一级细分级别,进入第二细分级别,如下图所示. 提示:当处于最高级别细分等级时,可以选择 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZO97wb.html" rel="bookmark" class="title">谷歌输入法怎么设置模糊拼音？</a>
					<div>
						  第一步:打开谷歌输入法的状态栏 第二步:点击&quot;设置&quot;的图标(要启用模糊拼音,只需点击输入状态栏上的&quot;设置&quot;键),选择&quot;属性设置&quot; --- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGj4Yop.html" rel="bookmark" class="title">飞信的功能特性</a>
					<div>
						飞信具有以下功能特性: 飞信功能: 1.免费文字聊天.移动速配.PC对PC语音视频聊天免费,PC对手机语音视频聊天双向收费,手机对手机语音视频聊天也是双向收费. 2.通过电脑或手机的飞信客户端免费发送 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd7NN4M.html" rel="bookmark" class="title">如何找回XP系统程序丢失的兼容性选项卡</a>
					<div>
						如何找回XP系统程序丢失的兼容性选项卡   解决方法: 1.鼠标点击&quot;开始&quot;菜单,选择&quot;运行&quot;选项,在弹出的对话框中输入&quot;gpedit.msc&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8263b.html" rel="bookmark" class="title">15个别出心裁的全屏导航网站设计欣赏</a>
					<div>
						  在没看到这组网站之前,你绝对想象不到网站导航也能这么标新立异,光动效就秒杀一片.如果你有过在某个网站迷路的经历,见到这组全屏导航网站定会登时一惊:业界良心莫过如此. KLM's – Flat or ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYZ7jM.html" rel="bookmark" class="title">Win7通知区域中的系统图标&OpenCurlyDoubleQuote;操作中心&rdquo;显示灰色怎么办</a>
					<div>
						  操作中心显示灰色图: 解决步骤: 1.打开控制面板,点击打开&quot;操作中心&quot;项; 2.在打开的操作中心界面中,点击窗口左侧的&quot;更改用户账户控制设置&quot;项; 3.在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQN7PwM.html" rel="bookmark" class="title">Kaggle机器学习之模型融合（stacking）心得</a>
					<div>
						此文道出了本人学习Stacking入门级应用的心路历程. 在学习过程中感谢@贝尔塔的模型融合方法,以及如何在 Kaggle 首战中进入前 10%这篇文章(作者是章凌豪).对于两位提供的信息,感激不尽. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQ148z.html" rel="bookmark" class="title">皮尔逊 余弦 相似度有C 的代码实现库吗</a>
					<div>
						问题描述 皮尔逊 余弦 相似度有C 的代码实现库吗 皮尔逊 余弦 相似度有C 的代码实现库吗 最近需要用到这两个函数					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32ldNz.html" rel="bookmark" class="title">java-split&lpar;&rpar;方法使用怎么使用？</a>
					<div>
						问题描述 split()方法使用怎么使用? 我写了这样一段代码: public CaiFen{ String str1=&quot;hello world&quot;; String a[]=str1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAEQGM.html" rel="bookmark" class="title">cstring-MFC中Cstring 中的Format函数</a>
					<div>
						问题描述 MFC中Cstring 中的Format函数 这个错误是什么啊 该怎么调试 解决方案 CString::Format()函数MFC format函数详解MFC format函数详解 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgV2j8b.html" rel="bookmark" class="title">《计算机科学导论》一2&period;2　位置化数字系统</a>
					<div>
						2.2 位置化数字系统 在位置化数字系统中,数字中符号所占据的位置决定了其表示的值.在该系统中,数字这样表示: 它的值是: 其中,S是一套符号集:b是底(或基数),它等于S符号集中的符号总数,其中S1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAawJM.html" rel="bookmark" class="title">Swift学习之九：基本运行符&lpar;Basic Operators&rpar;</a>
					<div>
						基本运行符: +(加法.正数) - (减法.负数) *  (乘法) / (除法) % (求余)  : 在Swift中,求余可以是浮点数求余. &amp;&amp;(逻辑与)  || (逻辑或) ^ ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYqALp.html" rel="bookmark" class="title">Mirantis使用Kubernetes容器化OpenStack以缓解运维挑战</a>
					<div>
						本文讲的是Mirantis使用Kubernetes容器化OpenStack以缓解运维挑战[编者的话]Swapnil是印度著名的记者和作家,其领域横跨Linux和开源软件.同时他也是印度有名的科幻作家. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvmle1b.html" rel="bookmark" class="title">cxf-求CXF对象传递的完整示例</a>
					<div>
						问题描述 求CXF对象传递的完整示例 求CXF对象传递的完整示例 求CXF对象传递的完整示例 求CXF对象传递的完整示例					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNjyOJM.html" rel="bookmark" class="title">只发表情，也能聊个把小时？表情符号正代替文字</a>
					<div>
						&lt;纽约时报&gt;网络版周日刊登署名为杰西卡·班尼特(Jessica Bennett)的文章指出,表情符号已成为人们当前沟通聊天的潮流方式,有人甚至只用表情就能聊上个把小时.某种程度而言,表情符 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7Pjwp.html" rel="bookmark" class="title">readonly的麻烦</a>
					<div>
						问题描述 DimrsAsNewADODB.RecordsetDimobjSheetAsExcel.Worksheetrs(0)=objSheet.Cells(i,1)问什么显示属性item为reado ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4ekQjb.html" rel="bookmark" class="title">这些老外的开源技术养活了一票国产软件</a>
					<div>
						现在各种国产软件已经牢牢占据了国内市场,无论是在浏览器.下载软件.压缩软件还是视频播放器等领域,都可以看到国产软件活跃的身影.诚然,国产软件在很多方面体验都不错,但之所以它们这么强,很大程度上是因为在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3J1V3z.html" rel="bookmark" class="title">两个内容相同但是类名不同的文件，但是为啥运行不了</a>
					<div>
						问题描述 有两个内容相同但是类名不同的文件,但是运行时只有RPG2.java能运行,QAZ.java运行不了.求助前辈们packagecc.openhome;publicclassRPG2{publi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7Qkez.html" rel="bookmark" class="title">现在 使用 SSH框架的公司多么</a>
					<div>
						问题描述 现在 Java开发中 SSH 是否还是主流框架?想要从事Java开发 是否需要熟练掌握 SSH框架?熟练掌握 SSH 对Java程序员是否真的很重要? 解决方案 SSH 现在已经不是主流框架 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKqY6Ep.html" rel="bookmark" class="title">python的正则表达式re模块的常用方法&lowbar;python</a>
					<div>
						1.re的简介 使用python的re模块,尽管不能满足所有复杂的匹配情况,但足够在绝大多数情况下能够有效地实现对复杂字符串的分析并提取出相关信息.python 会将正则表达式转化为字节码,利用 C  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6nwnM.html" rel="bookmark" class="title">Javascript中匿名函数的多种调用方式总结&lowbar;javascript技巧</a>
					<div>
						Javascript中定义函数的方式有多种,函数直接量就是其中一种.如var fun = function(){},这里function如果不赋值给fun那么它就是一个匿名函数.好,看看匿名函数的如何 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8Aj0p.html" rel="bookmark" class="title">struts2参数一直不丢失，怎么办&quest;</a>
					<div>
						问题描述 以前一直用struts1.2,过去参数一般都是action层用request.setAttribute把参数保存起来,在jsp页面上再用request.getAttribute或直接JSTL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRdw73z.html" rel="bookmark" class="title">阿里巴巴叕开源了！Apache基金会接收阿里中间件RocketMQ为孵化项目</a>
					<div>
						今年10月之前的时候,我们对阿里巴巴的开源项目做过一次整理,发现开源项目总计有73个之多.包括大名鼎鼎的OceanBase.AliSQL.Weex.JStorm.Tair.RocketMQ.Zeus. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWV7Wp.html" rel="bookmark" class="title">移动时代的斑马网：内容为王 走精品路线</a>
					<div>
						随着互联网技术的不断发展以及智能终端的普及,不仅推动了移动互联网的发展,也带来了移动APP应用的爆炸式增长.市面上不乏基于海量应用市场做移动APP推荐的网站和工具,但在各款移动APP中做深度探索,告诉 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.041 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
